import com.imsl.io.FlatFile;
import com.imsl.stat.Summary;
import java.io.*;
import java.sql.SQLException;
import java.util.StringTokenizer;


public class FlatFileEx1 extends FlatFile {    
   public FlatFileEx1(InputStream is) throws IOException {
      super(new BufferedReader(new InputStreamReader(is)));
      String line = readLine();
      StringTokenizer st = new StringTokenizer(line, ",");
      for (int j = 0;  st.hasMoreTokens();  j++) {
         setColumnName(j+1, st.nextToken().trim());
         setColumnClass(j, Double.class);
      }
   }

   public static void main(String[] args) throws SQLException, IOException {
      InputStream is = FlatFileEx1.class.getResourceAsStream("FisherIris.csv");
      FlatFileEx1 iris = new FlatFileEx1(is);

      Summary summary = new Summary();
      while (iris.next()) {
         summary.update(iris.getDouble("Sepal Width"));
      }

      System.out.println("Sepal Width mean " + summary.getMean());
      System.out.println("Sepal Width variance " + summary.getVariance());
   }
}
